require 'rubygems'
require 'gosu'

                    # Instances of this class create ingredients the fall from the top of the screen at a regular interval

require 'ingredient.rb'

module RubyBurger
  class Factory
    def initialize(window)
      @window = window
      @ingredients = Array.new
                    # A list of all valid ingredient types. Add the name of the image to this array to add a new one
      @ingredient_types = ["top_bun", "tomato", "bacon", "patty"]
      @interval = 0
    end

    def update
                    # If the time is right, spawn another ingredient
      if (@interval == 50)
        create_ingredient
        @interval = 0
      end
                    # Change the time
      @interval += 1
                    # Update the ingredient
      @ingredients.each {|each| each.update}
    end

    def draw
                    # Draw every ingredient
      @ingredients.each {|each| each.draw}
    end

    def create_ingredient
                    # Spawn a random ingredient at a random position at the top of the screen and let it drop!
      @ingredients << FallingIngredient.new(@window, @ingredient_types.at(Gosu::random(0, @ingredient_types.length)), Gosu::random(0, @window.width - 50), 0)
    end

    def delete(ingredient)
                    # Delete the given ingredient
      @ingredients.delete(ingredient)
    end
  end
end